//+------------------------------------------------------------------+
//|                                               rsi chart bars.mq4 |
//|                                   Copyright  2008, thestellaman |
//|                            thestellamanrulestheworld@yahoo.co.uk |
//+------------------------------------------------------------------+
//miro1360: edit to next levels

#property copyright "Copyright  2008, thestellaman"
#property link      "http://www.thestellamanrulestheworld.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 C'81,182,225' //SkyBlue//wick
#property indicator_color2 C'175,54,54'  //Coral//wick
#property indicator_color3 C'81,182,225'  //SkyBlue//candle
#property indicator_color4 C'175,54,54' // Coral//candle
#property indicator_color5 Blue//wick
#property indicator_color6 MediumOrchid //Red//wick
#property indicator_color7 Blue//candle
#property indicator_color8 MediumOrchid  //Red//candle
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 2
#property indicator_width8 2


//---- stoch settings
extern string TimeFrame    = "60";
extern int	  RSI_Period	= 14;
extern int    RSI_Price    = 0;
extern int	  Overbought	= 50;
extern int	  Oversold		= 50;
extern int	  Overbought2	= 80;
extern int	  Oversold2		= 20;

//---- input parameters
extern int	BarWidth			= 1,
				CandleWidth		= 2;

//---- buffers
double Bar1[],
		 Bar2[],
		 Candle1[],
		 Candle2[],
		 Bar3[],
		 Bar4[],
		 Candle3[],
		 Candle4[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;
		 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	IndicatorShortName("RSI Candles:("+	RSI_Period+")");
	IndicatorBuffers(4);
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);				
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);
	SetIndexBuffer(4,Bar3);
	SetIndexBuffer(5,Bar4);				
	SetIndexBuffer(6,Candle3);
	SetIndexBuffer(7,Candle4);
	SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(4,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(5,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexStyle(6,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexStyle(7,DRAW_HISTOGRAM,0,CandleWidth);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

	return(0);
}

//+------------------------------------------------------------------+
double RSI (int i = 0)	{ int y = iBarShift(NULL,timeFrame,Time[i]); return(iRSI(NULL,timeFrame,RSI_Period,RSI_Price,y));}



//+------------------------------------------------------------------+
void SetCandleColor(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar1[i] = low;	Candle1[i] = bodyLow;
	Bar2[i] = low;	Candle2[i] = bodyLow;
//	Bar3[i] = low;	Candle3[i] = bodyLow;
//	Bar4[i] = low;	Candle4[i] = bodyLow;

	switch(col)
	{
		case 1: 	Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
		case 2: 	Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
//		case 3: 	Bar3[i] = high;	Candle3[i] = bodyHigh;	break;
//		case 4: 	Bar4[i] = high;	Candle4[i] = bodyHigh;	break;
	
	}
}

void SetCandleColor2(int col, int i)
{
	double high,low,bodyHigh,bodyLow;


	{
		bodyHigh = MathMax(Open[i],Close[i]);
		bodyLow  = MathMin(Open[i],Close[i]);
		high		= High[i];
		low		= Low[i];
	}

	Bar3[i] = low;	Candle3[i] = bodyLow;
	Bar4[i] = low;	Candle4[i] = bodyLow;

	switch(col)
	{
		case 1: 	Bar3[i] = high;	Candle3[i] = bodyHigh;	break;
		case 2: 	Bar4[i] = high;	Candle4[i] = bodyHigh;	break;
	
	}
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Bar1[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

	for(int i = limit; i>=0; i--)
	{
		double	rsi	= RSI(i);
		
				if(rsi > Overbought && rsi < Overbought2)		SetCandleColor(1,i);
		else	if(rsi < Oversold && rsi > Oversold2)		SetCandleColor(2,i);
				if(rsi >= Overbought2)		SetCandleColor2(1,i);
		else	if(rsi <= Oversold2)		SetCandleColor2(2,i);
	}
	

	return(0);
}
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}